<p align="center">
  <img src="https://upper.io/img/gopher.svg" width="256">
</p>

# upper/db [![Build Status](https://travis-ci.org/upper/db.svg?branch=v4)](https://travis-ci.org/upper/db) [![GoDoc](https://godoc.org/github.com/upper/db?status.svg)](https://pkg.go.dev/github.com/upper/db/v4)

`upper/db` is a productive data access layer (DAL) for [Go](https://golang.org)
that provides agnostic tools to work with different data sources, such as:

* [PostgreSQL](https://upper.io/v4/adapter/postgresql)
* [MySQL](https://upper.io/v4/adapter/mysql)
* [MSSQL](https://upper.io/v4/adapter/mssql)
* [CockroachDB](https://upper.io/v4/adapter/cockroachdb)
* [MongoDB](https://upper.io/v4/adapter/mongo)
* [QL](https://upper.io/v4/adapter/ql)
* [SQLite](https://upper.io/v4/adapter/sqlite)

See [upper.io/v4](//upper.io/v4) for documentation and code samples.

## The tour

![tour](https://user-images.githubusercontent.com/385670/91495824-c6fabb00-e880-11ea-925b-a30b94474610.png)

Take the [tour](https://tour.upper.io) to see real live examples in your
browser.

## License

Licensed under [MIT License](./LICENSE)

## Contributors

See the [list of contributors](https://github.com/upper/db/graphs/contributors).
